@using LSerialObserver.Domain.Observer

<div class="bg-light border rounded-3 shadow-sm p-4">
  <div class="mb-3">
    <h2 class="fs-3">Observer name</h2>
    <div>
      @if (Observer.IsEnabled)
      {
        <button class="btn btn-danger"
                @onclick="Observer.Disable">
          <i class="bi bi-stop-fill"></i>
          Disable
        </button>
      }
      else
      {
        <button class="btn btn-success"
                @onclick="Observer.Enable">
          <i class="bi bi-play-fill"></i>
          Enable
        </button>
      }

      <button class="btn btn-primary" disabled="@Observer.IsEnabled">
        <i class="bi bi-pencil-fill"></i>
        Edit
      </button>

      <button class="btn btn-danger" disabled="@Observer.IsEnabled">
        <i class="bi bi-trash"></i>
        Delete
      </button>
    </div>
  </div>

  @if (Observer.LatestPackage != null)
  {
    <div class="row row-cols-3 g-2">
      @foreach (var field in Observer.LatestPackage.Fields)
      {
        <div class="col">
          <div class="bg-white border rounded-3 p-2">
            <h3 class="fs-5">@field.Item1</h3>
            <div class="font-monospace">@field.Item2</div>
          </div>
        </div>
      }
    </div>
  }
  else
  {
    <div class="alert alert-warning d-inline-block mb-0">
      No recent data
    </div>
  }
</div>

@code {

  [Parameter]
  public Observer Observer { get; set; }

  protected override void OnInitialized()
  {
    Observer.Updated += _ => InvokeAsync(StateHasChanged);
  }

}
